package pdom;
/*
 * pDom.java
 *
 * Created on 2003/06/8
 */

import java.beans.*;
import java.lang.Exception;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.IOException;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilder; 
import javax.xml.parsers.DocumentBuilderFactory;  
import javax.xml.parsers.FactoryConfigurationError;  
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;  
import org.xml.sax.SAXParseException;
import java.util.ArrayList;

/*
 *
 * @author  tanaka
 * @version 0.5.1
 */
public class pDom extends Object implements java.io.Serializable {

    private static final String PROP_SAMPLE_PROPERTY = "SampleProperty";

    private String sampleProperty;

    private PropertyChangeSupport propertySupport;

    private OutputStreamWriter fw;
    
    private String encode;

    /** Creates new pDom */
    public pDom() {
        propertySupport = new PropertyChangeSupport ( this );
    }

    public String getSampleProperty () {
        return sampleProperty;
    }

    public void setSampleProperty (String value) {
        String oldValue = sampleProperty;
        sampleProperty = value;
        propertySupport.firePropertyChange (PROP_SAMPLE_PROPERTY, oldValue, sampleProperty);
    }


    public void addPropertyChangeListener (PropertyChangeListener listener) {
        propertySupport.addPropertyChangeListener (listener);
    }

    public void removePropertyChangeListener (PropertyChangeListener listener) {
        propertySupport.removePropertyChangeListener (listener);
    }

    public org.w3c.dom.Document create_document() throws Exception {
        Document document;
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.newDocument();  // Create from whole cloth
            return document;
        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            throw new Exception("create_document :" + pce );
        }
    }
    public org.w3c.dom.Document create_document(String file) throws Exception {
        Document document;
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.parse( new File(file) );
            return document;
        } catch (SAXException sxe) {
            // Error generated during parsing
            Exception  x = sxe;
            if (sxe.getException() != null)
                x = sxe.getException();
            throw new Exception("create_document :" + x );
        } catch (ParserConfigurationException pce) {
            // Parser with specified options can't be built
            throw new Exception("create_document :" + pce );
        } catch (IOException ioe) {
            // I/O error
            throw new Exception("create_document :" + ioe );
        }
    }
    public org.w3c.dom.NodeList get_elements(org.w3c.dom.Document document,String path) throws Exception {
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =document.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            throw new Exception("get_elements :" + path +"vf͂܂B" );
        org.w3c.dom.Element element = (org.w3c.dom.Element)nodeList.item(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1)
                    throw new Exception("get_elements :" + path +"vf͂܂B" );
                    element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return nodeList;
    }
    public org.w3c.dom.NodeList get_elements(org.w3c.dom.Element element,String path) throws Exception {
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =element.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            throw new Exception("get_elements :" + path +"vf͂܂B" );
        element = (org.w3c.dom.Element)nodeList.item(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1)
                    throw new Exception("get_elements :" + path +"vf͂܂B" );
                    element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return nodeList;
    }
    public Integer get_size(org.w3c.dom.NodeList nodelist){
        return new Integer(nodelist.getLength());
    }
    public org.w3c.dom.Element get_element(org.w3c.dom.NodeList nodelist,int index) throws Exception {
        int len = nodelist.getLength();
        if(len <1)
            throw new Exception("get_element : nodelistłB");
        if((index <0)||(index > len-1))
            throw new Exception("get_element : index̒l͈͊OłB");
        return (org.w3c.dom.Element)nodelist.item(index);
    }
    public org.w3c.dom.Element get_first_element (org.w3c.dom.Document document,String path) throws Exception {
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =document.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            throw new Exception("get_first_element :" + path +"vf܂B" );                
        org.w3c.dom.Element element = (org.w3c.dom.Element)nodeList.item(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1)
                    throw new Exception("get_first_element :" + path +"vf܂B" );                
                element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return element;
    }
    public org.w3c.dom.Element get_first_element (org.w3c.dom.Element element,String path) throws Exception {
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =element.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            throw new Exception("get_first_element :" + path +"vf܂B" );                
        element = (org.w3c.dom.Element)nodeList.item(0);
        if(path_array.size() > 1){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1)
                    throw new Exception("get_first_element :" + path +"vf܂B" );                
                element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return element;
    }
    public java.lang.Boolean is_exist_element (org.w3c.dom.Document document,String path){
        Boolean exist = Boolean.TRUE;
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =document.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            exist = Boolean.FALSE;
        org.w3c.dom.Element element = (org.w3c.dom.Element)nodeList.item(0);
        if((path_array.size() > 1)&&(exist == Boolean.TRUE)){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1){
                    exist = Boolean.FALSE;
                    break;
                }
                element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return exist;
    }
    public java.lang.Boolean is_exist_element (org.w3c.dom.Element element,String path){
        Boolean exist = Boolean.TRUE;
        int index=0;
        ArrayList path_array = new ArrayList();
        path = path.trim();
        while((index=path.indexOf('/')) != -1){
            if(index != 0){
                path_array.add(path.substring(0,index));
            }
            path = path.substring(index+1,path.length());
        }
        if(path != ""){
            path_array.add(path);
        }
        org.w3c.dom.NodeList nodeList;
        path = (String)path_array.get(0);
        nodeList =element.getElementsByTagName(path);
        if(nodeList.getLength()<1)
            exist = Boolean.FALSE;
        element = (org.w3c.dom.Element)nodeList.item(0);
        if((path_array.size() > 1)&&(exist == Boolean.TRUE)){
            for(int i=1;i<path_array.size();i++){
                path = (String)path_array.get(i);
                nodeList = element.getElementsByTagName(path);
                if(nodeList.getLength()<1){
                    exist = Boolean.FALSE;
                    break;
                }
                element = (org.w3c.dom.Element)nodeList.item(0);
            }
        }
        return exist;
    }
    public org.w3c.dom.Element get_parent (org.w3c.dom.Element element){
        return (org.w3c.dom.Element)element.getParentNode();
    }
    public org.w3c.dom.NodeList get_child_elements (org.w3c.dom.Element element,String child_name){
        return element.getElementsByTagName(child_name);
    }
    public String get_element_name (org.w3c.dom.Element element){
        return element.getTagName();
    }
    public String get_element_value(org.w3c.dom.Element element){
        NodeList nodeList = element.getChildNodes();
        String text = "";
        for(int i=0;i<nodeList.getLength(); i++){
            Node node = nodeList.item(i);
            int type = node.getNodeType();
            if(type == org.w3c.dom.Node.TEXT_NODE){
                text += node.getNodeValue();
            }
        }
        return text;
    }    
    public String get_child_value (org.w3c.dom.Element element,String child_name) throws Exception {
        NodeList nodeList = element.getElementsByTagName(child_name);
        if(nodeList.getLength()<1)
            throw new Exception("get_child_value : "+child_name+"vf͂܂B");
        Node node = nodeList.item(0);
        nodeList = node.getChildNodes();
        String text = "";
        for(int i=0;i<nodeList.getLength(); i++){
            node = nodeList.item(i);
            int type = node.getNodeType();
            if(type == org.w3c.dom.Node.TEXT_NODE){
                text += node.getNodeValue();
            }
        }
        return text;
    }
     public String get_attrib (org.w3c.dom.Element element,String attrib_name){ 
        return element.getAttribute(attrib_name);
    }
    public org.w3c.dom.Element make_element (org.w3c.dom.Document document,String element_name) throws Exception {
        try{
            org.w3c.dom.Element element = document.createElement(element_name);
            return element;
        } catch (DOMException dome) {
            throw new Exception("make_element :" + dome );
        }
    }
    public org.w3c.dom.Text make_text_node (org.w3c.dom.Document document,String text){
        org.w3c.dom.Text text_node = document.createTextNode(text);
        return text_node;
    }
    public void add_child_element (org.w3c.dom.Document document,org.w3c.dom.Element child) throws Exception {
        try{
            document.appendChild(child);
        } catch (DOMException dome) {
            throw new Exception("add_child_element :" + dome );
        }
    }
    public void add_child_element (org.w3c.dom.Element element,org.w3c.dom.Element child) throws Exception {
        try{
            element.appendChild(child);
        } catch (DOMException dome) {
            throw new Exception("add_child_element :" + dome );
        }
    }
    public void insert_child_element (org.w3c.dom.Element element,org.w3c.dom.Element child,org.w3c.dom.Element ref) throws Exception {
        try{
            element.insertBefore(child,ref);
        }catch (DOMException dome){
            throw new Exception("insert_child_element :" + dome);
        }
    }
    public void add_text_node (org.w3c.dom.Element element,org.w3c.dom.Text text_node) throws Exception {
        try{
            element.appendChild(text_node);
        } catch (DOMException dome) {
             throw new Exception("add_text_node :" + dome );
        }
    }
    public void set_attrib (org.w3c.dom.Element element,String attrib_name,String attrib_value) throws Exception {
        try{
            element.setAttribute(attrib_name,attrib_value);
        } catch (DOMException dome) {
            throw new Exception("set_attrib :" + dome );
        }
    }
    public void set_element_value (org.w3c.dom.Element element,String text) throws Exception {
        org.w3c.dom.Document document = element.getOwnerDocument();
        org.w3c.dom.Text text_node = document.createTextNode(text);
        org.w3c.dom.NodeList nodelist = element.getChildNodes();
        int len = nodelist.getLength();
        try{
            for(int i=0;i<len;i++){
                org.w3c.dom.Node node = nodelist.item(i);
                if(node.getNodeType() == org.w3c.dom.Node.TEXT_NODE)
                    element.removeChild(node);
            }
            element.appendChild(text_node);
        } catch (DOMException dome) {
            throw new Exception("set_element_value :" + dome );
        }
    }
    public void del_child_element (org.w3c.dom.Element element,org.w3c.dom.Element child) throws Exception {
        try{
            element.removeChild(child);
        } catch (DOMException dome) {
            throw new Exception("del_child_element :" + dome );
        }
    }
    public void del_text (org.w3c.dom.Element element) throws Exception {
        org.w3c.dom.NodeList nodelist = element.getChildNodes();
        int len = nodelist.getLength();
        try{
            for(int i=0;i<len;i++){
                org.w3c.dom.Node node = nodelist.item(i);
                if(node.getNodeType() == org.w3c.dom.Node.TEXT_NODE)
                    element.removeChild(node);
            }
        } catch (DOMException dome) {
            throw new Exception("del_text :" + dome );
        }
    }
    public void del_attrib (org.w3c.dom.Element element,String attrib_name) throws Exception {
        try{
            element.removeAttribute(attrib_name);
        } catch (DOMException dome) {
            throw new Exception("del_attrib :" + dome );
        }
    }
    public void write_document(org.w3c.dom.Document document,String filepath,String encoding) throws Exception {
        try{
            FileOutputStream fs = new FileOutputStream(filepath);
            String xml="";
            if((encoding == "EUC-JP") || (encoding == "euc-jp")){
                encode = "euc-jp";
                xml = "<?xml version=\"1.0\" encoding=\"EUC-JP\"?>\n";
            }else if((encoding == "Shift-JIS") || (encoding == "shift-jis") || (encoding == "SHIFT-JIS")){
                encode = "SJIS";
                xml = "<?xml version=\"1.0\" encoding=\"Shift-JIS\"?>\r\n";
            }else if((encoding == "SJIS") || (encoding == "sjis")){
                encode = "SJIS";
                xml = "<?xml version=\"1.0\" encoding=\"SJIS\"?>\r\n";
            }else if((encoding == "UTF-8") || (encoding == "utf-8")){
                encode = "utf-8";
                xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
            }else{
                xml = "<?xml version=\"1.0\" encoding=\""+encode+"\"?>\n";
            }
            fw = new OutputStreamWriter(fs,encode);
            fw_write(xml);
            org.w3c.dom.Element docelm = document.getDocumentElement();
            serializeNode((org.w3c.dom.Node)docelm,0);
            fw.close();
         } catch (IOException e) {
            throw new Exception("write_document :" + e );
        }
          
    }
    public void write_document(org.w3c.dom.Document document,String filepath) throws Exception {
        try{
            FileOutputStream fs = new FileOutputStream(filepath);
            String xml="";
            xml = "<?xml version=\"1.0\"?>\n";
            fw = new OutputStreamWriter(fs);
            fw_write(xml);
            org.w3c.dom.Element docelm = document.getDocumentElement();
            serializeNode((org.w3c.dom.Node)docelm,0);
            fw.close();
         } catch (IOException e) {
            throw new Exception("write_document :" + e );
        }
          
    }
    public void serializeNode(org.w3c.dom.Node node,int level) throws IOException { 
        switch (node.getNodeType()) { 
            case org.w3c.dom.Node.ELEMENT_NODE: 
                String tag = node.getNodeName();
                for(int j=0;j<level;j++){
                    fw_write("\t");
                }
                fw_write("<" + tag);
                org.w3c.dom.NamedNodeMap  attribs = node.getAttributes();
                for (int i = 0; i < attribs.getLength(); i++) {
                    org.w3c.dom.Node attrib = (org.w3c.dom.Node) attribs.item(i);
                    fw_write(" ");
                    String name = attrib.getNodeName();
                    fw_write(name);
                    fw_write("=");
                    fw_write("\"");
                    String value = attrib.getNodeValue();
                    fw_write(value);
                    fw_write("\"");
                }
                fw_write(">"); 
                org.w3c.dom.NodeList children = node.getChildNodes();
                boolean flg = false;
                for (int i = 0; i < children.getLength(); i++) {
                    if(children.item(i).getNodeType() == org.w3c.dom.Node.ELEMENT_NODE){
                        flg = true;
                        break;
                    }
                }
                if(flg){
                    if(encode == "SJIS"){
                        fw_write("\r");
                    }
                    fw_write("\n");
                    level++;
                }
                for (int l = 0; l < children.getLength(); l++) {
                    serializeNode(children.item(l),level);
                } 
                level--;
                if(flg){
                    for(int k=0;k<level;k++){
                        fw_write("\t");
                    }
                }
                if(encode == "SJIS"){
                    fw_write("</" + tag + ">\r\n");
                 }else{
                    fw_write("</" + tag + ">\n");
                 }
                 break; 

            case org.w3c.dom.Node.TEXT_NODE:
                String temp = node.getNodeValue();
                fw_write(temp.trim());
                break;
        }    
    }
    public void fw_write(String value) throws IOException{
        fw.write(value,0,value.length());
    }
}
